(*
 NewAC Inernet Radio Station Demo.
 Copyright (c) 2008, Andrei Borovsky, anb@symmetrica.net.
     NewAC (http://symmetrica.net/newac).
*)

unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ACS_Classes, StdCtrls, ComCtrls, ACS_DXAudio, Spin, ExtCtrls, ACS_Wave,
  ACS_WinMedia;

type
  TForm1 = class(TForm)
    StartButton: TButton;
    StatusBar1: TStatusBar;
    StopButton: TButton;
    Timer1: TTimer;
    Label2: TLabel;
    SpinEdit2: TSpinEdit;
    Label3: TLabel;
    Label4: TLabel;
    PauseButton: TButton;
    DXAudioIn1: TDXAudioIn;
    WMStreamedOut1: TWMStreamedOut;
    procedure StartButtonClick(Sender: TObject);
    procedure OutputDone(Sender: TComponent);
    procedure StopButtonClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SpinEdit2Change(Sender: TObject);
    procedure PauseButtonClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure WMStreamedOut1ThreadException(Sender: TComponent);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}


procedure TForm1.StartButtonClick(Sender: TObject);
begin
  StartButton.Enabled := False;
  SpinEdit2.Enabled := False;
  WMStreamedOut1.Run;
  Timer1.Interval := 1000;
end;


procedure TForm1.OutputDone(Sender: TComponent);
begin
  StartButton.Enabled := True;
  SpinEdit2.Enabled := True;
end;

procedure TForm1.StopButtonClick(Sender: TObject);
begin
  WMStreamedOut1.Stop;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Label2.Caption := Format(': %d ', [WMStreamedOut1.TimeElapsed]);
end;

procedure TForm1.WMStreamedOut1ThreadException(Sender: TComponent);
begin
  Self.StatusBar1.Panels[0].Text := WMStreamedOut1.ExceptionMessage;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  SpinEdit2.MaxValue := DXAudioIn1.DeviceCount - 1;
  SpinEdit2.MinValue := 0;
  SpinEdit2.Value := 0;
  Label4.Caption := DXAudioIn1.DeviceName[SpinEdit2.Value];
end;

procedure TForm1.SpinEdit2Change(Sender: TObject);
begin
  Label4.Caption := DXAudioIn1.DeviceName[SpinEdit2.Value];
  DXAudioIn1.DeviceNumber := SpinEdit2.Value;
end;

procedure TForm1.PauseButtonClick(Sender: TObject);
begin
  if WMStreamedOut1.Status = tosPlaying then WMStreamedOut1.Pause;
  if WMStreamedOut1.Status = tosPaused then WMStreamedOut1.Resume;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  WMStreamedOut1.Stop(False);
end;

end.
